/**
 * This module takes ownership of the window.respecConfig getter and setter
 * allowing for operations to be triggered once configuration is set.
 */
define(["core/respecEvents"], function (msg) {
  if (window.respecConfig) {
    return;
  }
  var internalConfig;
  Object.defineProperty(window, "respecConfig", {
    configurable: true,
    enumerable: true,
    get: function () {
      return internalConfig;
    },
    set: function (value) {
      internalConfig = value;
      msg.pub("configchange");
      return internalConfig;
    },
  });
});

