"use strict";
define([], function () {
  function runAll(plugs) {
    respecEvents.pub("start", this.name);
    var promisesToFinish = plugs
      .filter(function (plug) {
        // excludes self, non-runnable, and modules that return falsy objects
        return plug && typeof plug.run === "function" && plug !== this;
      })
      .map(function (plug) {
        return new Promise(function (resolve) {
          plug.run(respecConfig, document, resolve, respecEvents);
        });
      });
    return Promise
      .all(promisesToFinish)
      .then(function () {
        respecEvents.pub("end", this.name);
        document.respecDone = true;
      })
      .catch(function (err) {
        // Runtime errors should not be reported to user. Only explicitly messages.
        throw err;
      });
  }

  function PluginRunner(name){
    this.name = name;
  }

  PluginRunner.prototype = {
    runAll: function(){
      return runAll.call(this);
    },
    name: null,
  };
  return PluginRunner;
});
