"use strict";
define([], function () {
  // pubsub
  // freely adapted from http://higginsforpresident.net/js/static/jq.pubsub.js
  var handlers = {};
  var respecEvents = {
    pub: function (topic) {
      // Nothing to do...
      if (!handlers[topic]) {
        return;
      }
      var args = Array
        .from(arguments)
        .slice(1);
      if (window.top !== window.self) {
        var clones = args
          .map(function toStructuredCloneCompatible(arg) {
            return String(arg.stack || arg);
          });
        var msg = {
          topic: topic,
          args: clones,
        };
        window.parent.postMessage(msg, window.location.origin);
      }
      handlers[topic]
        .forEach(function (cb) {
          cb.apply(window, args);
        });
    },
    sub: function (topic, cb) {
      var callbacks = handlers[topic];
      if (!callbacks) {
        callbacks = []
        handlers[topic] = callbacks;
      }
      callbacks.push(cb);
      return [topic, cb];
    },
    unsub: function (opaque) { // opaque is whatever is returned by sub()
      var topic = handlers[opaque[0]];
      var cb = opaque[1];
      if (!topic || !handlers.includes(cb)) {
        return;
      }
      topic.splice(topic.indexOf(cb), 1);
    }
  };
  if (window.console) {
    respecEvents.sub("warn", function (details) {
      console.warn(details);
    });
    respecEvents.sub("error", function (details) {
      console.error(details);
    });
    respecEvents.sub("start", function (details) {
      if (respecConfig && respecConfig.trace) console.log(">>> began: " + details);
    });
    respecEvents.sub("end", function (details) {
      if (respecConfig && respecConfig.trace) console.log("<<< finished: " + details);
    });
  }
  return respecEvents;
});
